/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.Tarifa;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import java.util.List;

/**
 *
 * @author rodrigo
 */
public interface TarifaDAO extends GenericDAO<Tarifa, Integer> {

    public List<Tarifa> pesquisar(Marca marca, Parada origem, Parada destino, Moneda moneda,
            ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa,
            Categoria categoria, TipoPuntoVenta tipoPuntoVenta);

    public boolean existe(Marca marca, Tramo tramo, Moneda moneda, ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa);
    
    public List<Tarifa> pesquisar(Marca marca, Tramo tramo, Moneda moneda,
            ClaseServicio claseServicio, VigenciaTarifa vigenciaTarifa);

    public Tarifa buscar(Tramo tramo, Marca marca, ClaseServicio claseServicio,
            VigenciaTarifa vigenciaTarifa, Moneda moneda);

    public List<Tarifa> buscarPorVigencia(VigenciaTarifa vigencia);

    public List<Tarifa> pesquisar(List<Moneda> lsMoneda, List<Marca> lsMarca,
            List<ClaseServicio> lsClaseServicio, List<Categoria> lsCategoria,
            List<Empresa> lsEmpresa, List<Ruta> lsRuta,
            List<TipoPuntoVenta> lsTipoPuntoVenta, List<VigenciaTarifa> lsVigenciaTarifa);

    public List<Tarifa> buscarExisteVigencia(VigenciaTarifa vigenciaTarifa);
}
