package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.OrgaoConcedenteDAO;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;

@Repository("orgaoConcedenteDAO")
public class OrgaoConcedenteHibernateDAO extends GenericHibernateDAO<OrgaoConcedente, Integer>
		implements OrgaoConcedenteDAO {

	@Autowired
	public OrgaoConcedenteHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<OrgaoConcedente> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq("activo", Boolean.TRUE));
		c.addOrder(Order.asc("descOrgao"));

		return c.list();
	}

	@SuppressWarnings("unchecked")
	@Override
	public List<OrgaoConcedente> buscar(String desc) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.like("descOrgao", desc));
		c.add(Restrictions.eq("activo", Boolean.TRUE));

		return c.list();
	}
}
