/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.PricingOcupacionDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingOcupacion;
import java.math.BigDecimal;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("pricingOcupacionDAO")
public class PricingOcupacionHibernateDAO extends GenericHibernateDAO<PricingOcupacion, Integer>
        implements PricingOcupacionDAO {

    @Autowired
    public PricingOcupacionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PricingOcupacion> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public Boolean podeSalvar(Pricing pricing, BigDecimal min, BigDecimal max) {
        Boolean retorno = Boolean.TRUE;

        StringBuilder hql = new StringBuilder("SELECT pv FROM PricingOcupacion pv ");
        hql.append(" WHERE pv.activo = 1 ");
        hql.append(" AND pv.pricing.pricingId = ").append(pricing.getPricingId());
        hql.append(" AND ( ");
        hql.append(" ( ").append(min).append(" BETWEEN ocupacioninicial AND ocupacionfinal )   ");
        hql.append(" OR ( ").append(max).append(" BETWEEN ocupacioninicial AND ocupacionfinal) ");
        hql.append(" OR ((ocupacioninicial BETWEEN ").append(min).append(" AND ").append(max).append(" )  OR (ocupacionfinal BETWEEN ").append(min).append(" AND ").append(max).append(" )))");

        Query sq = getSession().createQuery(hql.toString());

        List ls = sq.list();
        if (!ls.isEmpty()) {
            retorno = Boolean.FALSE;
        }

        return retorno;
    }

    public List<PricingOcupacion> podeSalvar(Pricing pricing) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("pricing", pricing));

        return c.list();
    }
}
