package com.rjconsultores.ventaboletos.dao.sqlbuilder;

import org.apache.log4j.Logger;

import com.rjconsultores.ventaboletos.dao.sqlbuilder.impl.SQLBuilderOracle;
import com.rjconsultores.ventaboletos.dao.sqlbuilder.impl.SQLBuilderSQLServer;
import com.rjconsultores.ventaboletos.dao.util.DBUtil;

public class SQLFactory {
	private static Logger log = Logger.getLogger(SQLFactory.class);

	public SQLBuilder getBuilder() {
		if (DBUtil.getInstance().isOracle()) {
			return new SQLBuilderOracle();
		}
		if (DBUtil.getInstance().isSQLServer()) {
			return new SQLBuilderSQLServer();
		}

		log.error("No foi identificado a base de dados");

		return new SQLBuilderOracle();
	}
}
