/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CONVENIO_SEQ", sequenceName = "CONVENIO_SEQ", allocationSize = 1)
@Table(name = "CONVENIO")
public class Convenio implements Serializable {

    public static final Short IMPRIME_PRECO_TOTAL = 1;
    public static final Short IMPRIME_PRECO_MENOS_DESCONTO = 2;
    public static final Short IMPRIME_DESCONTO = 3;
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CONVENIO_SEQ")
    @Basic(optional = false)
    @Column(name = "CONVENIO_ID")
    private Integer convenioId;
    @Column(name = "DESCCONVENIO")
    private String descconvenio;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "CVECONVENIO")
    private String cveconvenio;
    @Column(name = "VALIDAFOLIO")
    private Boolean validafolio;
    @Column(name = "IMPRIMEPRECIO")
    private Short imprimeprecio;
    @OneToMany(cascade = CascadeType.ALL)
    @JoinColumn(name = "CONVENIO_ID", referencedColumnName = "CONVENIO_ID")
    private List<ConvenioDet> convenioDetList;

    public Convenio() {
    }

    public Convenio(Integer convenioId) {
        this.convenioId = convenioId;
    }

    public Integer getConvenioId() {
        return convenioId;
    }

    public void setConvenioId(Integer convenioId) {
        this.convenioId = convenioId;
    }

    public String getDescconvenio() {
        return descconvenio;
    }

    public void setDescconvenio(String descconvenio) {
        this.descconvenio = descconvenio;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public String getCveconvenio() {
        return cveconvenio;
    }

    public void setCveconvenio(String cveconvenio) {
        this.cveconvenio = cveconvenio;
    }

    public Boolean getValidafolio() {
        return validafolio;
    }

    public void setValidafolio(Boolean validafolio) {
        this.validafolio = validafolio;
    }

    public Short getImprimeprecio() {
        return imprimeprecio;
    }

    public void setImprimeprecio(Short imprimeprecio) {
        this.imprimeprecio = imprimeprecio;
    }

    public List<ConvenioDet> getConvenioDetList() {
        List<ConvenioDet> tmp = new ArrayList<ConvenioDet>();
        if (convenioDetList != null) {
            for (ConvenioDet cd : this.convenioDetList) {
                if (cd.getActivo()) {
                    tmp.add(cd);
                }
            }
        }

        return tmp;
    }

    public void setConvenioDetList(List<ConvenioDet> convenioDetList) {
        this.convenioDetList = convenioDetList;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (convenioId != null ? convenioId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Convenio)) {
            return false;
        }
        Convenio other = (Convenio) object;
        if ((this.convenioId == null && other.convenioId != null) || (this.convenioId != null && !this.convenioId.equals(other.convenioId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.Convenio[convenioId=" + convenioId + "]";
    }
}
