/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PUNTO_VENTA_SEQ", sequenceName = "PUNTO_VENTA_SEQ", allocationSize = 1)
@Table(name = "PUNTO_VENTA")
public class PuntoVenta implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PUNTO_VENTA_SEQ")
    @Column(name = "PUNTOVENTA_ID")
    private Integer puntoventaId;
    @Column(name = "NOMBPUNTOVENTA")
    private String nombpuntoventa;
    @Column(name = "DIRECCIONCALLE")
    private String direccioncalle;
    @Column(name = "DIRECCIONNUMERO")
    private String direccionnumero;
    @Column(name = "STATUSAPROBACION")
    private String statusaprobacion;
    @Column(name = "COMENTARIOS")
    private String comentarios;
    @Column(name = "NUMTELEFONOUNO")
    private String numtelefonouno;
    @Column(name = "NUMTELEFONODOS")
    private String numtelefonodos;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "DESCCORREO")
    private String descCorreo;
    @OneToOne
    @JoinColumn(name = "EMPRESA_ID")
    private Empresa empresa;
    @OneToOne
    @JoinColumn(name = "COLONIA_ID")
    private Colonia colonia;
    @OneToOne
    @JoinColumn(name = "MONEDA_ID")
    private Moneda moneda;
    @OneToOne
    @JoinColumn(name = "PARADA_ID")
    private Parada parada;
    @JoinColumn(name = "TIPOPTOVTA_ID", referencedColumnName = "TIPOPTOVTA_ID")
    @ManyToOne
    private TipoPuntoVenta tipoPuntoVenta;
    @OneToMany(mappedBy = "puntoVenta")
    private List<ReservacionPuntoVenta> reservacionPuntoventaList;
    @OneToOne
    @JoinColumn(name = "NODO_ID")
    private Nodo nodo;
    @Column(name = "INDCONEXIONBANCARIA")
    private String conexionBancaria;
    @Column(name = "DSCUSUARIOINTERNET")
    private String dscUsuarioInternet;
    @Column(name = "DSCCONTRASENAINTERNET")
    private String dscContrasenaInternet;
    @OneToOne
    @JoinColumn(name = "USUARIOBANCARIO_ID")
    private UsuarioBancario usuarioBancario;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    private List<FormaPagoDet> lsFormaPagoDet;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    private List<ParamRecoleccion> lsParamRecoleccion;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    private List<PtovtaEmpresa> lsPtovtaEmpresa;
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    @JoinColumn(name = "PUNTOVENTA_ID", referencedColumnName = "PUNTOVENTA_ID")
    private List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario;

    public PuntoVenta() {
    }

    public PuntoVenta(Integer puntoventaId) {
        this.puntoventaId = puntoventaId;
    }

    public Integer getPuntoventaId() {
        return puntoventaId;
    }

    public void setPuntoventaId(Integer puntoventaId) {
        this.puntoventaId = puntoventaId;
    }

    public Nodo getNodo() {
        return nodo;
    }

    public void setNodo(Nodo nodo) {
        this.nodo = nodo;
    }

    public String getNombpuntoventa() {
        return nombpuntoventa;
    }

    public void setNombpuntoventa(String nombpuntoventa) {
        this.nombpuntoventa = nombpuntoventa;
    }

    public String getDireccioncalle() {
        return direccioncalle;
    }

    public void setDireccioncalle(String direccioncalle) {
        this.direccioncalle = direccioncalle;
    }

    public String getDireccionnumero() {
        return direccionnumero;
    }

    public void setDireccionnumero(String direccionnumero) {
        this.direccionnumero = direccionnumero;
    }

    public String getStatusaprobacion() {
        return statusaprobacion;
    }

    public void setStatusaprobacion(String statusaprobacion) {
        this.statusaprobacion = statusaprobacion;
    }

    public String getComentarios() {
        return comentarios;
    }

    public void setComentarios(String comentarios) {
        this.comentarios = comentarios;
    }

    public String getNumtelefonouno() {
        return numtelefonouno;
    }

    public void setNumtelefonouno(String numtelefonouno) {
        this.numtelefonouno = numtelefonouno;
    }

    public String getNumtelefonodos() {
        return numtelefonodos;
    }

    public void setNumtelefonodos(String numtelefonodos) {
        this.numtelefonodos = numtelefonodos;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public TipoPuntoVenta getTipoPuntoVenta() {
        return tipoPuntoVenta;
    }

    public void setTipoPuntoVenta(TipoPuntoVenta tipoPuntoVenta) {
        this.tipoPuntoVenta = tipoPuntoVenta;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public List<ReservacionPuntoVenta> getReservacionPuntoventaList() {
        return reservacionPuntoventaList;
    }

    public void setReservacionPuntoventaList(List<ReservacionPuntoVenta> reservacionPuntoventaList) {
        this.reservacionPuntoventaList = reservacionPuntoventaList;
    }

    public Moneda getMoneda() {
        return moneda;
    }

    public void setMoneda(Moneda moneda) {
        this.moneda = moneda;
    }

    public List<FormaPagoDet> getLsFormaPagoDet() {
        List<FormaPagoDet> tmp = new ArrayList<FormaPagoDet>();
        if (lsFormaPagoDet != null) {
            for (FormaPagoDet ddab : this.lsFormaPagoDet) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsFormaPagoDet = tmp;

        return tmp;
    }

    public List<ParamRecoleccion> getLsParamRecoleccion() {
        List<ParamRecoleccion> tmp = new ArrayList<ParamRecoleccion>();
        if (this.lsParamRecoleccion != null) {
            for (ParamRecoleccion ddab : this.lsParamRecoleccion) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsParamRecoleccion = tmp;

        return tmp;
    }

    public List<PtovtaEmpresa> getLsPtovtaEmpresa() {
        List<PtovtaEmpresa> tmp = new ArrayList<PtovtaEmpresa>();
        if (this.lsPtovtaEmpresa != null) {
            for (PtovtaEmpresa ddab : this.lsPtovtaEmpresa) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsPtovtaEmpresa = tmp;

        return tmp;

//        return lsPtovtaEmpresa;
    }

    public void setLsPtovtaEmpresa(List<PtovtaEmpresa> lsPtovtaEmpresa) {
        this.lsPtovtaEmpresa = lsPtovtaEmpresa;
    }

    public List<PtoVtaUsuarioBancario> getLsPtovtaUsuarioBancario() {
        List<PtoVtaUsuarioBancario> tmp = new ArrayList<PtoVtaUsuarioBancario>();
        if (this.lsPtovtaUsuarioBancario != null) {
            for (PtoVtaUsuarioBancario ddab : this.lsPtovtaUsuarioBancario) {
                if (ddab.getActivo()) {
                    tmp.add(ddab);
                }
            }
        }

        this.lsPtovtaUsuarioBancario = tmp;

        return tmp;
        //return lsPtovtaUsuarioBancario;
    }

    public void setLsPtovtaUsuarioBancario(List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario) {
        this.lsPtovtaUsuarioBancario = lsPtovtaUsuarioBancario;
    }

    public void setLsParamRecoleccion(List<ParamRecoleccion> lsParamRecoleccion) {
        this.lsParamRecoleccion = lsParamRecoleccion;
    }

    public String getConexionBancaria() {
        return conexionBancaria;
    }

    public void setConexionBancaria(String conexionBancaria) {
        this.conexionBancaria = conexionBancaria;
    }

    public UsuarioBancario getUsuarioBancario() {
        return usuarioBancario;
    }

    public void setUsuarioBancario(UsuarioBancario usuarioBancario) {
        this.usuarioBancario = usuarioBancario;
    }

    public void setLsFormaPagoDet(List<FormaPagoDet> lsFormaPagoDet) {
        this.lsFormaPagoDet = lsFormaPagoDet;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (puntoventaId != null ? puntoventaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PuntoVenta)) {
            return false;
        }
        PuntoVenta other = (PuntoVenta) object;
        if ((this.puntoventaId == null && other.puntoventaId != null) || (this.puntoventaId != null && !this.puntoventaId.equals(other.puntoventaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return this.getNombpuntoventa();
    }

    /**
     * @return the colonia
     */
    public Colonia getColonia() {
        return colonia;
    }

    /**
     * @param colonia the colonia to set
     */
    public void setColonia(Colonia colonia) {
        this.colonia = colonia;
    }

    public Parada getParada() {
        return parada;
    }

    public void setParada(Parada parada) {
        this.parada = parada;
    }

    public String getDescCorreo() {
        return descCorreo;
    }

    public void setDescCorreo(String descCorreo) {
        this.descCorreo = descCorreo;
    }

    public String getDscContrasenaInternet() {
        return dscContrasenaInternet;
    }

    public void setDscContrasenaInternet(String dscContrasenaInternet) {
        this.dscContrasenaInternet = dscContrasenaInternet;
    }

    public String getDscUsuarioInternet() {
        return dscUsuarioInternet;
    }

    public void setDscUsuarioInternet(String dscUsuarioInternet) {
        this.dscUsuarioInternet = dscUsuarioInternet;
    }
}
