/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author rodrigo
 */
@Entity
@Table(name = "TARIFA_CATEGORIA")
@SequenceGenerator(name = "TARIFA_CATEGORIA_SEQ", sequenceName = "TARIFA_CATEGORIA_SEQ", allocationSize = 1)
public class TarifaCategoria implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TARIFA_CATEGORIA_SEQ")
    @Column(name = "TARIFACATEGORIA_ID")
    private Integer tarifacategoriaId;
    @Column(name = "PRECIO")
    private BigDecimal precio;
    @Column(name = "PRECIOREDABIERTO")
    private BigDecimal precioredabierto;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @OneToOne
    @JoinColumn(name = "CATEGORIA_ID")
    private Categoria categoria;

    public TarifaCategoria() {
    }

    public TarifaCategoria(Integer tarifacategoriaId) {
        this.tarifacategoriaId = tarifacategoriaId;
    }

    public Integer getTarifacategoriaId() {
        return tarifacategoriaId;
    }

    public void setTarifacategoriaId(Integer tarifacategoriaId) {
        this.tarifacategoriaId = tarifacategoriaId;
    }

    public BigDecimal getPrecio() {
        return precio;
    }

    public void setPrecio(BigDecimal precio) {
        this.precio = precio;
    }

    public BigDecimal getPrecioredabierto() {
        return precioredabierto;
    }

    public void setPrecioredabierto(BigDecimal precioredabierto) {
        this.precioredabierto = precioredabierto;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tarifacategoriaId != null ? tarifacategoriaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TarifaCategoria)) {
            return false;
        }
        TarifaCategoria other = (TarifaCategoria) object;
        if ((this.tarifacategoriaId == null && other.tarifacategoriaId != null) || (this.tarifacategoriaId != null && !this.tarifacategoriaId.equals(other.tarifacategoriaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.TarifaCategoria[tarifacategoriaId=" + tarifacategoriaId + "]";
    }
}
