package com.rjconsultores.ventaboletos.service;

import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;


public interface TarifaOficialService {

	/**
	 * Gera as tarifas de acordo o clculo da ANTT.<br/>
	 * 
	 * Se o parametro ruta no for informado, ser gerado tarifas para todas as
	 * rutas da ANTT.<br/>
	 * 
	 * Obs.: Essa opero apenas gera tarifas que ainda no esto geradas<br/>
	 * 
	 * @param rutaId
	 * @return A quantidade de registros afetadas
	 */
	public Integer gerarTarifaANTT(Integer rutaId);

	/**
	 * Atualiza as tarifas de acordo o clculo da ANTT<br/>
	 * 
	 * Se o parametro ruta no for informado, ser atualizado as tarifas para
	 * todas as rutas da ANTT.<br/>
	 * 
	 * @param rutaId
	 * @return TODO
	 */
	public Integer atualizarTarifaANTT(Integer rutaId);
	
	/**
	 * Copia a tarifa oficial para a tabela de tarifa de acordo com a vigencia especificada
	 * @param vigenciaTarifa
	 */
	public void copiarParaTarifa(VigenciaTarifa vigenciaTarifa);

}
