/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service;

import java.util.List;

import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.vo.esquemaoperacional.RutaTramoVO;
import com.rjconsultores.ventaboletos.vo.esquemaoperacional.SecuenciaRutaTramoVO;


/**
 *
 * @author Administrador
 */
public interface TramoRutaService {
	/**
	 * Grava la nueva configuracin de la ruta con los tramos.
	 * 
	 * Si no existen los tramos, ellos son generados.
	 * 
	 * 
	 * @param rutaTramoVO
	 * @throws BusinessException - Si hay algun valor no valido; Si la ruta ya existe
	 */
	public Ruta generarTramosRutas(RutaTramoVO rutaTramoVO) throws BusinessException;
	
	/**
	 * Genera la combinacion de la ruta.
	 * 
	 * @param rutaTramoVO
	 * @return
	 */
	public List<SecuenciaRutaTramoVO> generarCombinacion(RutaTramoVO rutaTramoVO);
	
	/**
	 * Renera los datos de regreso para la ruta informada
	 * @param rutaTramoVO
	 * @return
	 */
	public RutaTramoVO generarRutaRegreso(RutaTramoVO rutaTramoVO);
}
