/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingAsientoDAO;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingAsiento;
import com.rjconsultores.ventaboletos.service.PricingAsientoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingAsientoService")
public class PricingAsientoServiceImpl implements PricingAsientoService {

    @Autowired
    private PricingAsientoDAO pricingAsientoDAO;

    public List<PricingAsiento> obtenerTodos() {
        return pricingAsientoDAO.obtenerTodos();
    }

    public PricingAsiento obtenerID(Integer id) {
        return pricingAsientoDAO.obtenerID(id);
    }

    @Transactional
    public PricingAsiento suscribir(PricingAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingAsientoDAO.suscribir(entidad);
    }

    @Transactional
    public PricingAsiento actualizacion(PricingAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingAsientoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingAsientoDAO.actualizacion(entidad);
    }

    public List<PricingAsiento> obtenerPricingCategoria(Pricing pricing, Integer asiento) {
        return pricingAsientoDAO.obtenerPricingCategoria(pricing, asiento);
    }
}
