/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PricingEspecificoDAO;
import com.rjconsultores.ventaboletos.entidad.PricingEspecifico;
import com.rjconsultores.ventaboletos.service.PricingEspecificoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("pricingEspecificoService")
public class PricingEspecificoServiceImpl implements PricingEspecificoService {

    @Autowired
    private PricingEspecificoDAO pricingEspecificoDAO;

    public List<PricingEspecifico> obtenerTodos() {
        return pricingEspecificoDAO.obtenerTodos();
    }

    public PricingEspecifico obtenerID(Integer id) {
        return pricingEspecificoDAO.obtenerID(id);
    }

    @Transactional
    public PricingEspecifico suscribir(PricingEspecifico entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingEspecificoDAO.suscribir(entidad);
    }

    @Transactional
    public PricingEspecifico actualizacion(PricingEspecifico entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return pricingEspecificoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(PricingEspecifico entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        pricingEspecificoDAO.actualizacion(entidad);
    }

    public List<PricingEspecifico> buscarPorNome(PricingEspecifico pricingEspecifico) {
        return pricingEspecificoDAO.buscarPorNome(pricingEspecifico);
    }
}
