package com.rjconsultores.ventaboletos.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.TarifaOficialDAO;
import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.TarifaOficialService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("tarifaOficialService")
public class TarifaOficialServiceImpl implements TarifaOficialService {

	@Autowired
	private TarifaOficialDAO tarifaOficialDAO;
	
	@Override
	@Transactional
	public Integer gerarTarifaANTT(Integer rutaId) {
		return tarifaOficialDAO.gerarTarifaANTT(rutaId);
	}

	@Override
	@Transactional
	public Integer atualizarTarifaANTT(Integer rutaId) {
		return tarifaOficialDAO.atualizarTarifaANTT(rutaId,UsuarioLogado.getUsuarioLogado().getUsuarioId());
	}

	@Override
	@Transactional
	public void copiarParaTarifa(VigenciaTarifa vigenciaTarifa) {
		tarifaOficialDAO.copiarParaTarifa(vigenciaTarifa, UsuarioLogado.getUsuarioLogado().getUsuarioId());
	}

}
