/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.utilerias;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import org.apache.log4j.Logger;
import org.springframework.core.io.ClassPathResource;

/**
 * Clase con las propriedad especificas de los clientes
 * @author Administrador
 */
public class ApplicationProperties {

    private static Logger log = Logger.getLogger(ApplicationProperties.class);
    private static ApplicationProperties INSTANCE;
    private static Properties p;

    private ApplicationProperties() {
        p = new Properties();
        this.readConfiguration();
    }

    private void readConfiguration() {
        try {

            InputStream is = new ClassPathResource("/com/rjconsultores/ventaboletos/web/cliente/conf/application.properties").getInputStream();
            p.load(is);
            is.close();
        } catch (IOException e) {
            log.error(e);
        }
    }

    public static ApplicationProperties getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new ApplicationProperties();
        }

        return INSTANCE;
    }
    
    /**
     * Indica se la informacion de equivalencia es visible
     * @return
     */
    public boolean mostrarEquivalencia(){
    	 String property = p.getProperty("equivalencia.mostrar", "0");
    	 return property.equals("1");
    }
    /**
     * Indica se es gerado o campo equivalencia corrida na tabela de corrida
     * @return
     */
    public boolean gerarCampoEquivalenciaCorrida(){
    	String property = p.getProperty("corrida.gerarCampoEquivalencia", "0");
    	return property.equals("1");
    }
    /**
     * Indica exibe o combo de Division na Gera��o de Corridas do Esquema Operacional.
     * @return
     */
    public boolean exibirDivisionConfiguracionCorrida(){
    	String property = p.getProperty("esquemaOperacional.configuracionCorrida.exibeDivision", "0");
    	return property.equals("1");
    }
    /**
     * Indica se va a exhibir la cuenta contable en el catalogo de tipos de eventos
     * @return
     */
    public boolean exhibirCuentaContableTiposEventos(){
    	String property = p.getProperty("eventosExtras.tiposEventos.exhibirCuentaContable", "1");
    	return property.equals("1");
    }
    /**
     * Indica se va a exhibir la "aba" de excepciones de tramo_km en la pantalla de tramos
     * @return
     */
    public boolean exhibirExcepcionesTramoKm(){
    	String property = p.getProperty("tramos.exhibirExcepcionesTramoKm", "0");
    	return property.equals("1");
    }
    /**
     * Indica se vai exibir botão na modificação massiva de tarifa de
     * geração automatica de tarifas
     * @return
     */
    public boolean generarTarifasAutomatica(){
    	String property = p.getProperty("tarifa.generarTarifasAutomatica", "0");
    	return property.equals("1");
    }
    
    
}
